#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>

#define CTOP 10000UL

volatile unsigned char stat;
unsigned char sw;				// XCb`ϐ
unsigned char sw_flag;			// XCb`ωtO

ISR(PCINT1_vect)	// sω荞݃nh
{
	stat = 1;
}

void update_sw()
{
	static unsigned long cnt;
	switch (stat) {
	case 0:
		return;
	case 1:
		cnt = CTOP;
		stat = 2;
		return;
	case 2:
		cnt--;
		if (cnt == 0) {
			sw = ~(PINC >> 4) & 3;	// ϐswXV
			sw_flag = 1;	// tO𗧂Ă
			stat = 0;
		}
		return;
	}
}

int main()
{
	DDRB = 0xFF;
	DDRC = 0x0F;
	DDRD = 0xFE;

	PORTB = 0x18;
	PORTC = 0x30;	// ̓svAbv
	PORTD = 0x00;

	PCICR = _BV(PCIE1);
	PCMSK1 = 0x30;
	sei();

	for (;;) {	// Cxg[v
		wdt_reset();
		update_sw();
		if (sw_flag) {
			sw_flag = 0;	// tONA
			switch (sw) {
			case 0:
				break;
			case 1:
				PORTB = (PORTB >> 7) | (PORTB << 1);
				break;
			case 2:
				PORTB = (PORTB << 7) | (PORTB >> 1);
				break;
			case 3:
				PORTB = ~PORTB;
				break;
			}
		}
	}
	return 0;
}
