#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>

volatile unsigned char led[8] =
  { 0x00, 0x57, 0x55, 0x77, 0x11, 0x17, 0x00, 0xFF };
volatile unsigned char mv_flag;

void update_led();

ISR(TIMER0_COMPA_vect)	// IȏLq
{
	static int cnt;
	cnt++;
	if (cnt == 100) {
		cnt = 0;
		mv_flag = 1;	// 200msƂɃZbg
	}
	update_led();	// _Ci~bN_    
}

void update_led()
{
	static unsigned char sc = 0xFE;
	static unsigned char scan = 0;

	PORTB = 0;	// c΍
	sc = (sc << 1) | (sc >> 7);
	PORTD = (PORTD & 0x0F) | (sc & 0xF0);	// 4rbg           
	PORTC = (PORTC & 0xF0) | (sc & 0x0F);	// 4rbg           
	scan = (scan + 1) & 7;
	PORTB = led[scan];
}

int main()
{
	unsigned char n;

	DDRB = 0xFF;
	DDRC = 0x0F;
	DDRD = 0xFE;

	PORTB = 0x00;
	PORTC = 0x30;
	PORTD = 0x00;

	// ^C}ݒ
	TCNT0 = 0;
	OCR0A = 249;
	TCCR0A = 2;
	TCCR0B = 3;
	TIMSK0 |= _BV(OCIE0A);	// RyA}b`A荞(2ms)

	sei();
	for (;;) {
		wdt_reset();
		if (mv_flag == 1) {
			mv_flag = 0;
			for (n = 0; n <= 7; n++) {
				led[n] = (led[n] << 1) | (led[n] >> 7);
			}
		}
	}
	return 0;
}
