#include<avr/io.h>
#include<avr/wdt.h>
#include<avr/interrupt.h>

#include "ringbuf.h"
#define BAUD 38400

/* * * * * * * * * Mp * * * * * * * * * * * */
ISR(USART_RX_vect)
{	/*  M荞    */
	char c;
	c = UDR0;
	if (!rx_write(c)) {	// MOobt@Ɉڂ
		PORTB = (PORTB << 1) | 1;	// obt@Ԃ\
	}
}

/* * * * * * * * * * Mp * * * * * * * * * * * */
ISR(USART_UDRE_vect)
{	/*  Mf[^WX^󊄂荞 */
	char c;
	if (!tx_read(&c)) {	// MOobt@o
		UDR0 = c;	// M
	}
	else {
		UCSR0B &= ~_BV(UDRIE0);	// 󂫊荞ݖ
	}
}

/* * * * * * * * *  AvP[V * * * * * * * * * */

ISR(TIMER1_COMPA_vect)
{
	char x;
	char tone[] = { 238, 212, 189, 174, 158, 141, 126, 118 };

	OCR2A = 0;
	if (!rx_read(&x)) {	// MOobt@o
		UCSR0B |= _BV(UDRIE0);	// 󂫊荞ݗL 
		PORTB >>= 1;

		if ((x >= '1') && (x <= '8')) {
			OCR2A = tone[x - '1'];
			tx_write(x);	// MOobt@ɏ            
		}
		else {
			tx_write('*');
		}
	}
}

int main(void)
{
	DDRD = 0xFE;
	DDRC = 0x0F;
	DDRB = 0xFF;

	PORTD = 0x00;
	PORTC = 0x30;
	PORTB = 0x00;

	/* ʐMxݒ */
	UBRR0 = (F_CPU >> 4) / BAUD - 1;
	UCSR0A = 0;

	/* f[^8rbgCpeBȂCXgbvrbg1 */
	UCSR0C = 0x06;
	UDR0 = 0;

	/* M̗LCM荞ݗL */
	UCSR0B = _BV(RXCIE0) | _BV(RXEN0) | _BV(TXEN0);

	// ^C}1(荞ݗp)
	TCNT1 = 0;
	OCR1A = 2000;	// rl(`lA)
	TCCR1A = 0x00;
	TCCR1B = 0x0D;
	TIMSK1 = _BV(OCIE1A);	// COMP A 荞ݗL

	// ^C}2(uU[p)
	TCCR2B = 0x04;
	TCCR2A = 0x12;
	OCR2B = OCR2A = 0;

	sei();

	for (;;) {
		wdt_reset();
	}
	return 0;
}
