#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <stdlib.h>	// itoa()
#include <string.h>	// strcat()

#define BAUD 38400
enum ADC_MUX
{
	PHOTO_TR = 0x5,				// ZT(ADC5)
	LED1 = 0x4,	// LED1(LED4)
	IV1 = 0xE	// d1.1V
};

enum ADC_MUX adev = PHOTO_TR;	// ΏۂI
volatile unsigned int val;
volatile unsigned char adc_flag = 0;
volatile char buff[16];

ISR(ADC_vect)
{
	TIFR1 = _BV(OCF1B);	// gKp̃tÕNA
	val = ADC;
	adc_flag = 1;
	if (adev == LED1) {	// LED͌͂ɓ݊Ȃ̂ŁC̑΍
		DDRC |= 0x10;	// o̓sɕύX
		PORTC &= ~0x10;	// o͓d0Vɂ(d)
		DDRC &= ~0x10;	// ̓sɖ߂
	}
}

ISR(USART_UDRE_vect)
{
	static char n;
	UDR0 = buff[n++];
	if (buff[n] == '\0') {
		UCSR0B &= ~_BV(UDRIE0);	// 󂫊荞ݒ~
		n = 0;
	}
}

int main(void)
{
	// LED  SW1,2 ̃|[gݒ
	DDRD = 0xFE;
	DDRC = 0x0F;
	DDRB = 0xFF;

	PORTD = 0x00;
	PORTC = 0x00;
	PORTB = 0x00;

	OCR1A = 49999;
	OCR1B = 0;
	TCCR1A = 0;
	TCCR1B = 0xA;	// PS=8, CTC, 50msƂCompBtO   

	ADMUX = _BV(REFS0);	// REFd(AVCC)
	ADMUX |= adev;	// ADC͂̐ݒ
	ADCSRB = 5;	// gK(TIMER1_COMPB)
	ADCSRA = _BV(ADEN) | 0x7 | _BV(ADATE) | _BV(ADIE);
	ADCSRA |= _BV(ADSC);	// ADIFNAƕϊJn

	/* ʐMxݒ */
	UBRR0 = (F_CPU >> 4) / BAUD - 1;
	UCSR0A = 0;

	/* f[^8rbgCpeBȂCXgbvrbg1 */
	UCSR0C = 0x06;
	UCSR0B = _BV(TXEN0);

	sei();

	for (;;) {
		wdt_reset();
		if (adc_flag) {
			itoa(val, buff, 10);
			strcat(buff, "\r\n");

			/* 󂫊荞ݗL */
			UCSR0B |= _BV(UDRIE0);
			adc_flag = 0;
		}
	}
	return 0;
}
