#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include "user.h"

volatile uchar sw;				//  {^       
volatile uchar sw_flag;			// XCb`ωtO(NA̓[UŎ{) 
volatile uchar led[LED_SZ];		//  }gNXLED      

static volatile uchar period;	//  uU[̒       
static volatile uchar user_flag;	//  [U[̊JntO 
static volatile uchar delay;	//  ҂ԃJE^    
static volatile uchar rnd;		//  [̃JE^ 

/* }gNXLED̃_Ci~bN_(2ms) */
ISR(TIMER0_COMPA_vect) // 
{
	static uchar sc = 0xFE;
	static uchar scan = 0;		//  LED JE^

	// LED̍XV 
	PORTB = 0;	// c΍
	sc = (sc << 1) | (sc >> 7);
	PORTD = (PORTD & 0x0F) | (sc & 0xF0);	// 4rbg
	PORTC = (PORTC & 0xF0) | (sc & 0x0F);	// 4rbg
	scan = (scan + 1) & 7;
	PORTB = led[scan];
}

/* XCb` */
ISR(PCINT1_vect) 
{
	OCR1A = TCNT1 + 500;	// ^C}1ɔrlݒ(64msɊ荞)
	TIFR1 = _BV(OCF1A);	    // tONA
	TIMSK1 |= _BV(OCIE1A);	// ^C}1ERyA}b`A荞ݗL
	rnd++;	                // XV
}
ISR(TIMER1_COMPA_vect) // `^OIC64msɌĂяo
{
	sw = (~PINC >> 4) & 3;	// XCb`ϐ̍XV
	sw_flag = 1;
	TIMSK1 &= ~_BV(OCIE1A);	// ^C}1ERyA}b`A荞ݖ   
}

/* [Û߂̊荞 */
ISR(TIMER1_COMPB_vect) // 100msƂɌĂяo
{	
	OCR1B = TCNT1 + 780;
	TIFR1 = _BV(OCF1B);	// tONA
	if (delay) {	// ҂
		delay--;
	}
	if (period) {	//  uU[~
		period--;
		if (period == 0) {
			TCCR2A = 0;
		}
	}
	user_flag = 1;	// [UR[hĂяo
}

int main(void)
{
	// LED,XCb`,uU[̃|[gݒ 
	DDRB = 0xFF;
	DDRC = 0x0F;
	DDRD = 0xFA;
	PORTC = 0x30;	// ̓svAbv
	PORTD = 0x00;

	// ^C}0(CTC): _Ci~bN_p  
	OCR0A = 249;	//  2mS     
	TCCR0A = 2;
	TCCR0B = 3;	//  1/64    
	TIMSK0 |= (1 << OCIE0A); // RyA}b`A荞ݗL

	// ^C}2(CTC): uU[p
	TCCR2A = 0;
	TCCR2B = 0x44;	//  1/64  , RyA}b`oBLigOj   

	// ^C}1(m[})F100ms̒荞
	TCCR1A = 0x00;
	TCCR1B = 0x05;
	TIMSK1 |= _BV(OCIE1B);	// RyA}b`B荞ݗL(100ms)
	TCNT1 = 0xFFFF;

	//  sω荞ݗL
	PCICR = _BV(PCIE1);
	PCMSK1 = 0x30;

	user_init();	// [U    
	sei();          // VXeƂĂ̊荞݂̗L
	for (user_flag = 0;;) {
		wdt_reset();
		if (user_flag) {	//  [U[̋N 
			user_main();
			user_flag = 0;
		}
	}
	return 0;
}

/* ԑ҂( n * 100ms) */
void _wait(uchar n)
{
	for (delay = n; delay;) {
		wdt_reset();
	}
}

/* [ */
uchar _rand(void)
{
	rnd++; 	// XV 
	return (uchar)(rnd ^ (rnd << 1)); 	// OCR[hJE^ 
}

/* uU[ */
void _sound(uchar tone, uchar length)
{
	OCR2A = tone;
	period = length;
	TCCR2A = 0x12;
}
