#include <string.h>
#include "user.h"

/*	[J֐	*/
static void MoveFort(void);
static void MoveEnemy(void);
static void MoveBullet(void);
static void UpdateLED(void);

/*	[Jϐ	*/
static uchar enemy[LED_SZ];		// G̈ʒu      
static uchar bullet[LED_SZ];	// ëʒu       
static uchar fort;				// C̒Sʒu  

/* [U[̏ */
void user_init(void)
{
	uchar i;

	for (i = 0; i < LED_SZ; i++) {
		enemy[i] = 0;
		bullet[i] = 0;
	}
	fort = 3;
}

/*	[U[i100mS ɌĂ΂j*/
void user_main(void)
{
	MoveFort();
	MoveEnemy();
	MoveBullet();
	UpdateLED();
}

/*	C̈ړ */
static void MoveFort(void)
{
	switch (sw) {
	case 1:	// ֈړ 
		if (fort > 1) {
			fort--;
		}
		break;
	case 2:	//  Eֈړ
		if (fort < (LED_SZ - 2)) {
			fort++;
		}
		break;
	case 3:	//  e̔
		if (sw_flag) {
			bullet[7] |= 0x140 >> fort;
			sw_flag = 0;
		}
		break;
	}
	sw_flag = 0;
}

/*	G̈ړ */
static void MoveEnemy(void)
{
	static uchar tick = 0;
	static uchar dir = 0;
	uchar i;

	if (++tick < 5)
		return;
	tick = 0;
	_sound(_rand() | 0x80, 1);
	switch (dir) {
	case 0:	//  Eֈړ
		for (i = 0; i < LED_SZ; i++) {
			enemy[i] >>= 1;
		}
		break;
	case 2:	//  ֈړ
		for (i = 0; i < LED_SZ; i++) {
			enemy[i] <<= 1;
		}
		break;
	default:	//  ֈړ
		if (enemy[7]) {
			_sound(10, 1);
			memset(enemy, 0, 8);
			_wait(5);
		}
		for (i = LED_SZ - 1; i; i--) {
			enemy[i] = enemy[i - 1];
		}
		enemy[i] = dir == 3 ? (_rand() & 0xFE) : 0;
		break;
	}
	dir = (dir + 1) & 3;
}

/*	ëړ */
static void MoveBullet(void)
{
	uchar i, j;

	//  ֈړ 
	for (i = 0; i < (LED_SZ - 1); i++) {
		bullet[i] = bullet[i + 1];
	}
	bullet[i] = 0;

	//  GɓΏ
	for (i = 0; i < LED_SZ; i++) {
		j = enemy[i] & bullet[i];
		if (j) {
			enemy[i] ^= j;
			bullet[i] ^= j;
			_sound(60, 1);
		}
	}
}

/*	LED\̍XV*/
static void UpdateLED(void)
{
	uchar i;

	//  Gƒe̍
	for (i = 0; i < LED_SZ; i++) {
		led[i] = enemy[i] | bullet[i];
	}

	//  C̍
	led[6] |= (uchar)(0x80 >> fort);
	led[7] |= (uchar)(0x1C0 >> fort);
}
