/*
* list3_7.c	-- Servo motor controller
*
* Author : Osamu Tamura @ Recursion Co., Ltd.
*/

/*
	ڑF
		PB5 -> Servo_6 Control Signal
		PB4 -> Servo_5 Control Signal
		PB3 -> Servo_4 Control Signal
		PB2 -> Servo_3 Control Signal
		PB1 -> Servo_2 Control Signal
		PB0 -> Servo_1 Control Signal
*/

#include "common.h"

#define SERVO_MAX	6

volatile unsigned char	tick;
volatile unsigned char	n;
volatile unsigned char	angle[SERVO_MAX];

// 16mS Ƃ̊荞
ISR(TIMER2_OVF_vect)
{
	//	T[{P̃pX LH
	n = 0;
	PORTB = 1;
	//	T[{P̃pXԌɊ荞(COMPAj
	OCR2A = angle[0];
	TIFR2 = _BV(OCF2A);
	TIMSK2 |= _BV(OCIE2A);

	tick++;
}

ISR(TIMER2_COMPA_vect)
{
	if (++n >= SERVO_MAX) {
		//	T[{ n-1 ̃pX HL
		PORTB = 0;
		//	荞ݒ~
		TIMSK2 &= ~_BV(OCIE2A);
		return;
	}
	//	T[{ n-1 ̃pX HL, n ̃pX LH
	PORTB = 1 << n;
	//	T[{ n ̃pXԌɊ荞
	OCR2A += angle[n];
	TIFR2 = _BV(OCF2A);
}


int main(void)
{
	unsigned char	i;

	init_clock(CLKPS_1MHz);

	DDRB	= 0x3f;
	PORTB	= 0x00;

	TCCR2A	= 0x00;
	TCCR2B	= 0x04;		//	1/64
	TIMSK2	= _BV(TOIE2);

	// T[{]p̏Ԑݒ
	for (i = 0; i < SERVO_MAX; i++) {
		angle[i] = 8 + 5 * i;
	}

	sei();
	for (;;) {
		wdt_reset();

		// T[{]p̐
		if (tick >= 12) {
			tick = 0;
			for (i = 0; i < SERVO_MAX; i++) {
				if (++angle[i] >= 38) {
					angle[i] = 8;
				}
			}
		}
    }
}

