/*
 * common.c
 *
 * Author : Osamu Tamura @ Recursion Co., Ltd.
 */

#include "common.h"

void init_clock(unsigned char scale)
{
	CLKPR = (1<<CLKPCE);
	CLKPR = scale;
}

void init_port()
{
	DDRB = 0xff;
	DDRC = 0x0f;
	DDRD = 0xfa;
	PORTB = 0;
	PORTC = 0x30;
	PORTD = 0;
}

inline unsigned char sw()
{
	unsigned char t = ~PINC;
	return (t >> 4) & 3;
}

void do_something(unsigned char x)
{
	PORTB ^= (1 << x); //x==1? 1:0x80;
}


void display_init(void)
{
	/*	CLK = 62500Hz, 600bps	*/
	UBRR0	= (unsigned char)((62500 >> 3) / 600 - 1);
	UCSR0A	= (1 << U2X0);
	/*  data 8bit, no parity, 1 stopbit */
	UCSR0C	= 0x06;
	UCSR0B	= (1 << TXEN0);
}

void display_data(char *data, unsigned char offset, unsigned char num)
{
	static char		tmp[12];
	unsigned char	i;

	//	XV̂݃obt@ɃRs[
	memcpy(tmp + offset, data + offset, num);
	//	obt@ŜVAo
	for (i = 0; i < 10; i++) {
		while ((UCSR0A & (1 << UDRE0)) == 0) {
			wdt_reset();
		}
		UDR0 = tmp[i];
	}
	//	o܂ő҂
	UCSR0A |= (1 << TXC0);
	while ((UCSR0A & (1 << TXC0)) == 0) {
		wdt_reset();
	}
}
