/*
 * list3_15.c	-- Traffic Light 1
 *
 * Author : Osamu Tamura @ Recursion Co., Ltd.
 */

#include "common.h"

enum {
	NS_GREEN,
	NS_YELLOW,
	NS_RED,
};

enum {
	TM_GREEN		= 12,
	TM_YELLOW		= 4,
	TM_RED			= (TM_GREEN+TM_YELLOW),
};

/*
	ڑF
		PB2 -> R ->  LEDiԗpj-> GND
		PB1 -> R ->  LEDiԗpj-> GND
		PB0 -> R ->  LEDiԗpj-> GND
*/
enum {
	LED_GREEN		= (1 << 2),
	LED_YELLOW		= (1 << 1),
	LED_RED			= (1 << 0),
};


int main(void)
{
	unsigned char	s = NS_GREEN;
	unsigned char	wait = TM_GREEN;

	init_clock(CLKPS_62500Hz);
	init_port();

	PORTB	= LED_GREEN;

	TCCR1A	= 0x00;
	TCCR1B	= 0x01;
	OCR1A	= 31249;		// 0.5 Sec

	for (;;)
	{
		wdt_reset();
		if ((TIFR1 & (1 << OCF1A)) == 0) {
			continue;
		}
		TIFR1 = (1 << OCF1A);

		switch (s) {
			case NS_GREEN:
				if (--wait == 0) {		// ̏ԂɈڂ
					PORTB = LED_YELLOW;	// ̏Ԃ̏
					wait = TM_YELLOW;
					s = NS_YELLOW;
					break;
				}
				// ܂̏Ԃł̏
				break;

			case NS_YELLOW:
				if (--wait == 0) {
					PORTB = LED_RED;
					wait = TM_RED;
					s = NS_RED;
				}
				break;

			case NS_RED:
				if (--wait == 0) {
					PORTB = LED_GREEN;
					wait = TM_GREEN;
					s = NS_GREEN;
				}
				break;
		}
	}
}


