/*
 * list3_16.c	-- Traffic Light 2
 *
 * Author : Osamu Tamura @ Recursion Co., Ltd.
 */

#include "common.h"

enum {
	SG_GREEN,
	SG_WALK_BLINK,
	SG_GREEN_RED,
	SG_YELLOW,
	SG_RED,
};

enum {
	TM_GREEN		= 16,
	TM_WALK_BLINK	= 8,
	TM_YELLOW		= 6,
	TM_BLINK		= 1
};

/*
	ڑF
		PB6 -> R ->  LEDiԗpj-> GND
		PB5 -> R ->  LEDiԗpj-> GND
		PB4 -> R ->  LEDiԗpj-> GND
		PB2 -> R ->  LEDisҗpj-> GND
		PB1 -> R ->  LEDisҗpj-> GND
*/
enum {
	LED_GREEN		= (1 << 6),
	LED_YELLOW		= (1 << 5),
	LED_RED			= (1 << 4),
	LED_WALK_GREEN	= (1 << 2),
	LED_WALK_RED	= (1 << 1),
};

int main(void)
{
	unsigned char	s = SG_YELLOW;
	unsigned char	dir = 0;
	unsigned char	wait = 1;
	unsigned char	blink = 0;
	unsigned char	button = 0;
	unsigned char	out = 0;
	unsigned char	outNS = 0;
	unsigned char	outEW = 0;

	init_clock(CLKPS_62500Hz);
	init_port();

	TCCR1A	= 0x00;
	TCCR1B	= 0x01;
	OCR1A	= 31249;	// 0.5 b

	for (;;)
	{
		wdt_reset();
		if ((TIFR1 & (1 << OCF1A)) == 0) {
			continue;
		}
		TIFR1 = (1 << OCF1A);

		switch (s) {
			case SG_GREEN:
			//	莞ԌɁ@΁isҁj @Γ_Łisҁj
			if (--wait == 0) {
				out = LED_GREEN;
				wait = TM_WALK_BLINK;
				blink = TM_BLINK;
				s = SG_WALK_BLINK;
				break;
			}
			//	s҂̉{^ @^CAEg𑁂߂
			if (wait >= 2) {
				button = sw();
				if ((dir == 0 && button == SW1) ||
					(dir == 1 && button == SW2)) {
					out ^= 0xff;
					wait = 2;
				}
			}
			break;

			case SG_WALK_BLINK:
			//	莞ԌɁ@Γ_Łisҁj ԁisҁj^iԗj
			if (--wait == 0) {
				out = LED_YELLOW | LED_WALK_RED;
				wait = TM_YELLOW;
				s = SG_YELLOW;
				break;
			}
			//	Γ_Łisҁj
			if (--blink == 0) {
				blink = TM_BLINK;
				out ^= LED_WALK_GREEN;
			}
			break;

			case SG_YELLOW:
			//	莞ԌɁ@iԗj ԁiԗj
			if (--wait == 0) {
				out = LED_GREEN | LED_WALK_GREEN;
				wait = TM_GREEN;
				s = SG_GREEN;
				dir ^= 1;	// ̐؂ւ
				break;
			}
			break;
		}

		// Mp^[o
		if (dir) {
			// k
			outNS = out;
			outEW = LED_RED | LED_WALK_RED;
		}
		else {
			// 
			outNS = LED_RED | LED_WALK_RED;
			outEW = out;
		}
		PORTB = outNS;
	}
}


