/*
	list3_26.c

	vGveBuE}`^XNF ReLXgEXCb`P

	Copyright(c) Recursion Co., Ltd. All rights reserved.
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>

extern void task_init(void);
extern void task_create( void *func );
extern volatile unsigned int     tick;	/* mS	*/

/* }gNXLED 0,1 i[e\g	*/
static void task_1( void )
{
	unsigned int    timeout = 0;
	unsigned char	m = 1;

	for( ;; ) {
		PORTB	= m;
		PORTC	= 0x1c;
		PORTD	= 0xf0;
		if ((int)(tick - timeout) >= 0) {
			timeout += 500;
			m = (m << 1) | (m >> 7);
		}
	}
}

/* }gNXLED 2,3 iE[e\g	*/
static void task_2( void )
{
	unsigned int    timeout = 0;
	unsigned char	m = 1;

	for( ;; ) {
		PORTB	= m;
		PORTC	= 0x03;
		PORTD	= 0xf0;
		if ((int)(tick - timeout) >= 0) {
			timeout += 200;
			m = (m >> 1) | (m << 7);
		}
	}
}

/* }gNXLED 4,5 i[e\g	*/
static void task_3( void )
{
	unsigned int    timeout = 0;
	unsigned char	m = 1;

	for( ;; ) {
		PORTB	= m;
		PORTC	= 0x0f;
		PORTD	= 0xc0;
		if ((int)(tick - timeout) >= 0) {
			timeout += 700;
			m = (m << 1) | (m >> 7);
		}
	}
}

/* }gNXLED 6,7 iE[e\g	*/
static void task_4( void )
{
	unsigned int    timeout = 0;
	unsigned char	m = 1;

	for( ;; ) {
		PORTB	= m;
		PORTC	= 0x0f;
		PORTD	= 0x30;
		if ((int)(tick - timeout) >= 0) {
			timeout += 900;
			m = (m >> 1) | (m << 7);
		}
	}
}

int main(void)
{
	/*  LED |[g̐ݒ    */
	DDRB    = 0xff;
	DDRC    = 0x1f;
	DDRD    = 0xfe;
	PORTB   = 0x42;

	/*    ^XN؂ւ荞݂̐ݒ    */
	task_init();

	/*    ^XN̐ƋN    */
	task_create(task_1);
	task_create(task_2);
	task_create(task_3);
	task_create(task_4);

	/*    ^XNXPW[̊Jn    */
	sei();
	for( ;; ) {           /*    Jn̂    */
		wdt_reset();
	}

	return 0;
}

